# -*- encoding: utf-8 -*-

from django.forms import widgets
from django.contrib import admin
from models import WorkflowMixin, NOM_CHAMPS_ETAT

class WorkflowAdmin(admin.ModelAdmin):
    
    def get_form(self, request, obj=None, **kwargs):
        """
        filtrage de la liste de choix d'état au moment où on a accès à l'objet request,
        pour le rendre disponible dans le workflow.
        """
        form = super(WorkflowAdmin, self).get_form(request, obj, **kwargs)
        if obj:
            form.base_fields[NOM_CHAMPS_ETAT].choices = obj.get_etats_disponibles(request)
        else:
            etat_initial = form.Meta.model.etat_initial
            libelle_etat_initial = form.Meta.model.etats[etat_initial]
            form.base_fields[NOM_CHAMPS_ETAT].choices = [(etat_initial, libelle_etat_initial), ]
        return form
